<template>
  <div v-if="categories.length" class="categories-tree">
    <v-list :dense="categories[0].level > 2" :class="categories[0].level > 2 ? 'ml-5' : ''">
      <div v-for="category in categories" :key="`categories-tree-${category.id}`">
        <v-list-item
          v-ripple="{ class: itemRippleClass }"
          nuxt
          :to="`${baseUrl}/${category.id}`"
          :active-class="itemActiveClass"
        >
          <v-list-item-icon v-if="category.level <= 2">
            <v-icon
              :color="categorySlug === category.id ? iconColorActive : iconColor"
              v-text="icons[category.id] || iconDefault"
            ></v-icon>
          </v-list-item-icon>

          <v-list-item-content>
            <v-list-item-title v-text="category.name"></v-list-item-title>
          </v-list-item-content>
        </v-list-item>

        <template v-if="category.children && selectedTree.includes(category.id)">
          <categories-tree
            :categories="category.children"
            :category-slug="categorySlug"
            :selected-tree="selectedTree"
          ></categories-tree>
        </template>
      </div>
    </v-list>
  </div>
</template>
<script>
export default {
  name: 'CategoriesTree',

  props: {
    categories: {
      type: Array,
      required: true,
    },

    categorySlug: {
      type: [Number, String],
      required: false,
      default: 0,
    },

    selectedTree: {
      type: Array,
      required: false,
      default() {
        return []
      },
    },

    itemActiveClass: {
      type: String,
      default: 'pink--text',
    },

    itemRippleClass: {
      type: String,
      default: 'indigo--text',
    },

    iconColor: {
      type: String,
      default: 'light-green',
    },

    iconColorActive: {
      type: String,
      default: 'pink',
    },

    iconDefault: {
      type: String,
      default: 'mdi-cloud',
    },
  },

  computed: {
    baseUrl() {
      return process.env.CATALOG_BASE_URL
    },

    icons() {
      return this.$store.state.catalog.icons
    },
  },
}
</script>
